﻿using System;
using System.Collections.Generic;
//using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using usb_api;

namespace WindowsApplication3
{
    public class ControlMovimiento
    {
        
        public UInt16 contadorInicialAcelTemp0,contadorInicialDecelTemp0;
        public byte valuePasosAceleracion,valuePasosDeceleracion;
        public UInt16 valueCorrienteFaseA, valueCorrienteFaseB;
        public enum tipoMovimiento : byte
        {
            PASOENTERO1FASE = 0x01,
            PASOENTERO2FASE = 0x02,
            MEDIOPASO = 0x32,
            MICROPASO = 0xEE
        }
        public byte byteTipoMovimiento;
        public byte byteSentidoGiro;
        private bool chekEntradas = true;
        private float valueVelocidadFinal; 
        private const int Fosc=31250;        //frequencia del oscilador del pic del temp Temp0
        private const byte GiroDerechas = 1, GiroIzquierdas = 0;

        private const double ConstContadorAcelDecel=0.26;
        
       
        bool[] casoFalloChekEntradas = new bool[3] { true, true, true };


        
        const string txantioiCorrientes = @"\b^[0][,][0-5][0-9]$|\b^[0]$|\b^[0][,][0-6]$";
        const UInt16 PWMdutyMax = 1020;
        const Double CorrienteMaxima = 0.6;
        const int NumPasosAcelDecelMax = 256;
        const string txantioiPasosAcelDecel = @"\b^[0-9]$|\b^[1-9][0-9]$|\b^1[0-9][0-9]$|\b^2[0-4][0-9]$|\b^25[0-5]$";
        const string txantioiVelocidadFinal = @"\b^[0-9]$|\b^[1-9][0-9]$|\b^1[0][0]$";
        
        float valueCorrienteFaseAfloat;
        float valueCorrienteFaseBfloat;
        //This is the constructor
        public ControlMovimiento(bool chekEntradas)
        {
            this.chekEntradas = chekEntradas;
        }
        //Corrientes entre 0 y 0,6 A con dos decimales y positivas
        public bool comprobarConvertirGrupoControMov(string stringPasosAceleracion,string stringPasosDeceleracion,string stringVelocidadFinal,string stringCorrientefaseA, string stringCorrientefaseB, bool boolSentidoGiroDerechas, bool boolPasoEnt2Fases, bool boolPasoEnt1Fase, bool boolMedioPaso)
            
        {
            
            Regex rgx1 = new Regex(txantioiCorrientes);
            MatchCollection matchesCurrentFaseA = rgx1.Matches(stringCorrientefaseA);
            MatchCollection matchesCurrentFaseB = rgx1.Matches(stringCorrientefaseB);
            Regex rgx2 = new Regex(txantioiPasosAcelDecel);
            MatchCollection matchespasosAceleracion = rgx2.Matches(stringPasosAceleracion);
            MatchCollection matchespasosDeceleracion = rgx2.Matches(stringPasosDeceleracion);
            Regex rgx3 = new Regex(txantioiVelocidadFinal);
            MatchCollection matchesVelocidadFinal = rgx3.Matches(stringVelocidadFinal);

            if (matchesCurrentFaseA.Count == 0 || matchesCurrentFaseB.Count == 0)
            {
                /*MessageBox.Show("Expresión numérica no válida." +
               "\rExpresiones válidas son del tipo:" +
               "\r 0; 0,1;0,15;...;0,6");*/
                chekEntradas = false;// Operation Failed
                casoFalloChekEntradas[0] = false;

            }
            else casoFalloChekEntradas[0] = true;     
            
            if (matchespasosAceleracion.Count == 0 || matchespasosDeceleracion.Count == 0)
            {
                /*bi bihurketa horiek azkenean dena ongi badoa
                 string newValueCorrienteFaseA = stringCorrientefaseA;
                 string newValueCorrienteFaseB = stringCorrientefaseB;
                 */

                chekEntradas = false;// Operation Failed
                casoFalloChekEntradas[1] = false;
            }
            else casoFalloChekEntradas[1] = true;

            if (matchesVelocidadFinal.Count == 0)
            {
                chekEntradas = false;// Operation Failed
                casoFalloChekEntradas[2] = false;
            }
            else casoFalloChekEntradas[2] = true;

            /* Create the event args object (BAINA EZ ORAIN MOTA HONETAN).

             KorronteenValueUpdatedEventArgs korronteenValueArgs =
                 new KorronteenValueUpdatedEventArgs(newValueCorrienteFaseA, newValueCorrienteFaseB);
             // Inform the observer. Orain egikaratzen da ondoko EVENT
             KorronteenValueUpdated(this, korronteenValueArgs);
              */
            //to insert values to convert and then pass to the USB
            if (chekEntradas == true)
            {
                //adapta las corrientes para pasarlas el buffer USB
                valueCorrienteFaseAfloat = float.Parse(stringCorrientefaseA);
                valueCorrienteFaseBfloat = float.Parse(stringCorrientefaseB);
                valueCorrienteFaseA = (UInt16)(valueCorrienteFaseAfloat * PWMdutyMax / CorrienteMaxima);
                valueCorrienteFaseB = (UInt16)(valueCorrienteFaseBfloat * PWMdutyMax / CorrienteMaxima);
                //adapta el núemro de pasos de acel y decel para pasarlas el buffer USB
                valuePasosAceleracion = byte.Parse(stringPasosAceleracion);
                valuePasosDeceleracion = byte.Parse(stringPasosDeceleracion);
                ////adapta la velo final desde rpm para pasarlas el buffer USB
                valueVelocidadFinal = 
                           (float) (float.Parse(stringVelocidadFinal) / 60 * (2 * Math.PI));
                contadorInicialAcelTemp0 = (UInt16)(0.676*Fosc * ConstContadorAcelDecel * Math.Sqrt(
                    valuePasosAceleracion / (valueVelocidadFinal * valueVelocidadFinal)));
                //Multiplicamos por 0.676  para compensar el error que se produce en le calculo de C0
                contadorInicialDecelTemp0 = (UInt16)(0.676*Fosc * ConstContadorAcelDecel * Math.Sqrt(
                    valuePasosDeceleracion / (valueVelocidadFinal*valueVelocidadFinal)));
                if (boolSentidoGiroDerechas == true) byteSentidoGiro = GiroDerechas;
                else byteSentidoGiro = GiroIzquierdas;
                if (boolPasoEnt2Fases == true) byteTipoMovimiento = (byte)tipoMovimiento.PASOENTERO2FASE;
                if (boolPasoEnt1Fase == true) byteTipoMovimiento = (byte)tipoMovimiento.PASOENTERO1FASE;
                if (boolMedioPaso == true) byteTipoMovimiento = (byte)tipoMovimiento.MEDIOPASO;
                MessageBox.Show("Confirmar");

                return true;
            }
            else
            {
               
                    
                    if (casoFalloChekEntradas[0] == false)
                        MessageBox.Show("CorrientefaseAoB");

                    if (casoFalloChekEntradas[1] == false)
                        MessageBox.Show("pasosAceleracionDeceleracion");
                    
                    if (casoFalloChekEntradas[2] == false)
                        MessageBox.Show("velocidad máxima superada");
                    
                return false;
                

            }
        }
    }
}

